"use client";
import {
  useTabsContext
} from "./chunk-P54SKJEH.mjs";

// src/tab-panel.tsx
import { forwardRef } from "@nextui-org/system";
import { useDOMRef } from "@nextui-org/react-utils";
import { clsx } from "@nextui-org/shared-utils";
import { mergeProps } from "@react-aria/utils";
import { useTabPanel } from "@react-aria/tabs";
import { useFocusRing } from "@react-aria/focus";
import { jsx } from "react/jsx-runtime";
var TabPanel = forwardRef((props, ref) => {
  var _a, _b, _c;
  const { as, className, ...otherProps } = props;
  const Component = as || "div";
  const domRef = useDOMRef(ref);
  const { slots, tabPanelId, state, classNames } = useTabsContext();
  const { tabPanelProps } = useTabPanel(props, state, domRef);
  const { focusProps, isFocused, isFocusVisible } = useFocusRing();
  const selectedItem = state.selectedItem;
  const content = selectedItem == null ? void 0 : selectedItem.props.children;
  const tabPanelStyles = clsx(classNames == null ? void 0 : classNames.panel, className, (_a = selectedItem.props) == null ? void 0 : _a.className);
  if (!content) {
    return null;
  }
  return /* @__PURE__ */ jsx(
    Component,
    {
      ref: domRef,
      "data-focus": isFocused,
      "data-focus-visible": isFocusVisible,
      ...mergeProps(tabPanelProps, focusProps, otherProps),
      "aria-labelledby": `${tabPanelId}-${(_b = state.selectedItem) == null ? void 0 : _b.key}`,
      className: (_c = slots.panel) == null ? void 0 : _c.call(slots, { class: tabPanelStyles }),
      "data-slot": "panel",
      id: tabPanelId,
      children: content
    }
  );
});
TabPanel.displayName = "NextUI.TabPanel";
var tab_panel_default = TabPanel;

export {
  tab_panel_default
};
