"use client";
"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Tab: () => tab_item_base_default,
  Tabs: () => tabs_default,
  useTabs: () => useTabs
});
module.exports = __toCommonJS(src_exports);

// src/tabs.tsx
var import_react2 = require("react");
var import_framer_motion2 = require("framer-motion");

// src/tabs-context.ts
var import_react_utils = require("@nextui-org/react-utils");
var [TabsProvider, useTabsContext] = (0, import_react_utils.createContext)({
  name: "TabsContext",
  strict: true,
  errorMessage: "useTabsContext: `context` is undefined. Seems you forgot to wrap component within <Tabs />"
});

// src/use-tabs.ts
var import_system = require("@nextui-org/system");
var import_theme = require("@nextui-org/theme");
var import_react_utils2 = require("@nextui-org/react-utils");
var import_shared_utils = require("@nextui-org/shared-utils");
var import_react = require("react");
var import_tabs = require("@react-stately/tabs");
var import_tabs2 = require("@react-aria/tabs");
var import_utils = require("@react-aria/utils");
function useTabs(originalProps) {
  const [props, variantProps] = (0, import_system.mapPropsVariants)(originalProps, import_theme.tabs.variantKeys);
  const { ref, as, className, children, classNames, disableCursorAnimation, ...otherProps } = props;
  const Component = as || "div";
  const domRef = (0, import_react_utils2.useDOMRef)(ref);
  const state = (0, import_tabs.useTabListState)({
    children,
    ...otherProps
  });
  const { tabListProps } = (0, import_tabs2.useTabList)(otherProps, state, domRef);
  const tabListId = (0, import_react.useId)();
  const tabPanelId = (0, import_react.useId)();
  const slots = (0, import_react.useMemo)(
    () => (0, import_theme.tabs)({
      ...variantProps,
      className
    }),
    [...Object.values(variantProps), className]
  );
  const baseStyles = (0, import_shared_utils.clsx)(className, classNames == null ? void 0 : classNames.base);
  const context = (0, import_react.useMemo)(
    () => ({
      state,
      slots,
      tabPanelId,
      classNames,
      listRef: domRef,
      disableCursorAnimation,
      isDisabled: originalProps == null ? void 0 : originalProps.isDisabled,
      disableAnimation: originalProps == null ? void 0 : originalProps.disableAnimation
    }),
    [
      state,
      slots,
      tabPanelId,
      domRef,
      disableCursorAnimation,
      originalProps == null ? void 0 : originalProps.disableAnimation,
      originalProps == null ? void 0 : originalProps.isDisabled,
      classNames
    ]
  );
  const getBaseProps = (props2) => ({
    "data-slot": "base",
    className: slots.base({ class: (0, import_shared_utils.clsx)(baseStyles, props2 == null ? void 0 : props2.className) }),
    ...(0, import_utils.mergeProps)((0, import_utils.filterDOMProps)(otherProps, { labelable: true }), props2)
  });
  const getTabListProps = (props2) => ({
    ref: domRef,
    "data-slot": "tabList",
    className: slots.tabList({ class: (0, import_shared_utils.clsx)(classNames == null ? void 0 : classNames.tabList, props2 == null ? void 0 : props2.className) }),
    ...(0, import_utils.mergeProps)(tabListProps, props2),
    id: tabListId
  });
  return {
    Component,
    domRef,
    state,
    context,
    getBaseProps,
    getTabListProps
  };
}

// src/tab.tsx
var import_system2 = require("@nextui-org/system");
var import_react_utils3 = require("@nextui-org/react-utils");
var import_shared_utils2 = require("@nextui-org/shared-utils");
var import_utils2 = require("@react-aria/utils");
var import_scroll_into_view_if_needed = __toESM(require("scroll-into-view-if-needed"));
var import_focus = require("@react-aria/focus");
var import_tabs3 = require("@react-aria/tabs");
var import_interactions = require("@react-aria/interactions");
var import_framer_motion = require("framer-motion");
var import_framer_transitions = require("@nextui-org/framer-transitions");
var import_use_is_mounted = require("@nextui-org/use-is-mounted");
var import_jsx_runtime = require("react/jsx-runtime");
var Tab = (0, import_system2.forwardRef)((props, ref) => {
  var _a;
  const { className, as, item, style, onClick, ...otherProps } = props;
  const { key } = item;
  const domRef = (0, import_react_utils3.useDOMRef)(ref);
  const Component = as || "button";
  const {
    slots,
    state,
    tabPanelId,
    listRef,
    disableCursorAnimation,
    isDisabled: isDisabledProp,
    disableAnimation,
    classNames
  } = useTabsContext();
  const {
    tabProps,
    isSelected,
    isDisabled: isDisabledItem,
    isPressed
  } = (0, import_tabs3.useTab)({ key }, state, domRef);
  const isDisabled = isDisabledProp || isDisabledItem;
  const { focusProps, isFocused, isFocusVisible } = (0, import_focus.useFocusRing)();
  const { hoverProps, isHovered } = (0, import_interactions.useHover)({
    isDisabled
  });
  const tabStyles = (0, import_shared_utils2.clsx)(classNames == null ? void 0 : classNames.tab, className);
  const ariaControls = (item == null ? void 0 : item.props.children) ? `${tabPanelId}-${key}` : void 0;
  const [, isMounted] = (0, import_use_is_mounted.useIsMounted)({
    rerender: true
  });
  const handleClick = () => {
    (0, import_utils2.chain)(onClick, tabProps.onClick);
    if (!(domRef == null ? void 0 : domRef.current) || !(listRef == null ? void 0 : listRef.current))
      return;
    (0, import_scroll_into_view_if_needed.default)(domRef.current, {
      scrollMode: "if-needed",
      behavior: "smooth",
      block: "end",
      inline: "end",
      boundary: listRef == null ? void 0 : listRef.current
    });
  };
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
    Component,
    {
      ref: domRef,
      "data-disabled": (0, import_shared_utils2.dataAttr)(isDisabledItem),
      "data-focus": (0, import_shared_utils2.dataAttr)(isFocused),
      "data-focus-visible": (0, import_shared_utils2.dataAttr)(isFocusVisible),
      "data-hover": (0, import_shared_utils2.dataAttr)(isHovered),
      "data-hover-unselected": (0, import_shared_utils2.dataAttr)((isHovered || isPressed) && !isSelected),
      "data-pressed": (0, import_shared_utils2.dataAttr)(isPressed),
      "data-selected": (0, import_shared_utils2.dataAttr)(isSelected),
      "data-slot": "tab",
      ...(0, import_utils2.mergeProps)(
        tabProps,
        !isDisabled ? {
          ...focusProps,
          ...hoverProps
        } : {},
        (0, import_utils2.filterDOMProps)(otherProps, { labelable: true })
      ),
      "aria-controls": ariaControls,
      className: (_a = slots.tab) == null ? void 0 : _a.call(slots, { class: tabStyles }),
      id: `${tabPanelId}-${key}`,
      style: {
        ...style,
        WebkitTapHighlightColor: "transparent"
      },
      onClick: handleClick,
      children: [
        isSelected && !disableAnimation && !disableCursorAnimation && isMounted ? /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          import_framer_motion.motion.span,
          {
            className: slots.cursor({ class: classNames == null ? void 0 : classNames.cursor }),
            "data-slot": "cursor",
            layoutDependency: false,
            layoutId: "cursor",
            transition: {
              ease: import_framer_transitions.TRANSITION_EASINGS.softSpring,
              duration: 0.6
            }
          }
        ) : null,
        /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
          "div",
          {
            className: slots.tabContent({
              class: classNames == null ? void 0 : classNames.tabContent
            }),
            "data-slot": "tabContent",
            children: item.rendered
          }
        )
      ]
    }
  );
});
Tab.displayName = "NextUI.Tab";
var tab_default = Tab;

// src/tab-panel.tsx
var import_system3 = require("@nextui-org/system");
var import_react_utils4 = require("@nextui-org/react-utils");
var import_shared_utils3 = require("@nextui-org/shared-utils");
var import_utils3 = require("@react-aria/utils");
var import_tabs4 = require("@react-aria/tabs");
var import_focus2 = require("@react-aria/focus");
var import_jsx_runtime2 = require("react/jsx-runtime");
var TabPanel = (0, import_system3.forwardRef)((props, ref) => {
  var _a, _b, _c;
  const { as, className, ...otherProps } = props;
  const Component = as || "div";
  const domRef = (0, import_react_utils4.useDOMRef)(ref);
  const { slots, tabPanelId, state, classNames } = useTabsContext();
  const { tabPanelProps } = (0, import_tabs4.useTabPanel)(props, state, domRef);
  const { focusProps, isFocused, isFocusVisible } = (0, import_focus2.useFocusRing)();
  const selectedItem = state.selectedItem;
  const content = selectedItem == null ? void 0 : selectedItem.props.children;
  const tabPanelStyles = (0, import_shared_utils3.clsx)(classNames == null ? void 0 : classNames.panel, className, (_a = selectedItem.props) == null ? void 0 : _a.className);
  if (!content) {
    return null;
  }
  return /* @__PURE__ */ (0, import_jsx_runtime2.jsx)(
    Component,
    {
      ref: domRef,
      "data-focus": isFocused,
      "data-focus-visible": isFocusVisible,
      ...(0, import_utils3.mergeProps)(tabPanelProps, focusProps, otherProps),
      "aria-labelledby": `${tabPanelId}-${(_b = state.selectedItem) == null ? void 0 : _b.key}`,
      className: (_c = slots.panel) == null ? void 0 : _c.call(slots, { class: tabPanelStyles }),
      "data-slot": "panel",
      id: tabPanelId,
      children: content
    }
  );
});
TabPanel.displayName = "NextUI.TabPanel";
var tab_panel_default = TabPanel;

// src/tabs.tsx
var import_jsx_runtime3 = require("react/jsx-runtime");
function Tabs(props, ref) {
  var _a;
  const { Component, state, context, getBaseProps, getTabListProps } = useTabs({
    ref,
    ...props
  });
  const layoutId = (0, import_react2.useId)();
  const layoutGroupEnabled = !props.disableAnimation && !props.disableCursorAnimation;
  return /* @__PURE__ */ (0, import_jsx_runtime3.jsxs)(TabsProvider, { value: context, children: [
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)("div", { ...getBaseProps(), children: /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(Component, { ...getTabListProps(), children: layoutGroupEnabled ? /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(import_framer_motion2.LayoutGroup, { id: layoutId, children: [...state.collection].map((item) => /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(tab_default, { item, ...item.props }, item.key)) }) : [...state.collection].map((item) => /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(tab_default, { item, ...item.props }, item.key)) }) }),
    /* @__PURE__ */ (0, import_jsx_runtime3.jsx)(tab_panel_default, {}, (_a = state.selectedItem) == null ? void 0 : _a.key)
  ] });
}
var tabs_default = (0, import_react2.forwardRef)(Tabs);
Tabs.displayName = "NextUI.Tabs";

// src/base/tab-item-base.ts
var import_aria_utils = require("@nextui-org/aria-utils");
var TabItemBase = import_aria_utils.BaseItem;
var tab_item_base_default = TabItemBase;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Tab,
  Tabs,
  useTabs
});
